unit CounterModel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ObservableComponent;

type
  TCounterModel = class(TObservableComponent)
  private
    { Private declarations }
    Value: Integer;
    procedure Changed;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent);
    procedure reset;
    procedure incr;
    procedure decr;
    function asString: string;

  published
    { Published declarations }
  end;

procedure Register;

implementation

constructor TCounterModel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Value := 0;
end;
procedure TCounterModel.Changed;
begin
  setChanged;
  notifyObservers(nil);;
end;

procedure TCounterModel.reset;
begin
  Value := 0;
  Changed;
end;

procedure TCounterModel.incr;
begin
  Value := Value + 1;
  Changed;
end;

procedure TCounterModel.decr;
begin
  Value := Value - 1;
  Changed;
end;

function TCounterModel.asString: string;
begin
  Result := IntToStr(Value);
end;

procedure Register;
begin
  RegisterComponents('Mvc', [TCounterModel]);
end;

end.
