unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  counterView, StdCtrls, ObservableComponent, CounterModel;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    lblCount: TLabel;
    Counter: TCounterModel;
    ObserverComponent1: TObserverComponent;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ObserverComponent1Update(arg: TObject);
  private
    { Private declarations }
    views : TList;
  public
    { Public declarations }

  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  views := TList.Create;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 newView : TTCounterView;
begin
  newView := TTCounterView.Create(self,counter);
  newView.Show;
  views.add(newView);
  lblCount.Caption := IntToStr(views.count);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if views.count > 0 then
  begin
//    TTCounterView(views[0]).hide;
    TTCounterView(views[0]).Destroy;
    views.delete(0);
  end;
  lblCount.Caption := IntToStr(views.count);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i : integer;
begin
  for i := 0 to views.count-1 do
  begin
    TTCounterView(views[i]).Destroy;
  end;
  views.clear;
  views.destroy;
end;

procedure TForm1.ObserverComponent1Update(arg: TObject);
begin
  label1.caption := counter.asString;
end;

end.
